package org.example.SnakeGame;

import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.input.KeyCode;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.example.StartScreen.StartScreen;

import java.net.URL;
import java.util.Random;
import java.util.ResourceBundle;

public class SnakeGameController implements Initializable {

    private final static Logger logger = LogManager.getLogger(SnakeGameController.class);
    private static final int radius = 5;
    private static final int step = 8;
    @FXML
    private AnchorPane anchorPane;


    //food
    private Circle food;
    private Random random;
    private Pane root;
    private Circle snake;

    /** methode will create the food
     * and display it randomly **/
    private void newFood(){
    food = new Circle(random.nextInt(598),random.nextInt(498), radius);
    food.setFill(Color.RED);
    anchorPane.getChildren().add(food);
    }

    private void newSnake(){
        snake = new Circle(300,250, radius+2);
        anchorPane.getChildren().add(snake);
    }


    @Override
    public void initialize(URL location, ResourceBundle resources) {

        random = new Random();

        newFood();
        newSnake();


        anchorPane.sceneProperty().addListener((observable, oldScene, newScene) -> {
            if (newScene != null) {
                newScene.setOnKeyPressed(event -> {
                    KeyCode code = event.getCode();

            if (code == KeyCode.UP){
                snake.setCenterY(snake.getCenterY()- step);
            }
            else if (code == KeyCode.DOWN){
                snake.setCenterY(snake.getCenterY() + step);
            }
            else if (code == KeyCode.LEFT) {
                snake.setCenterX(snake.getCenterX() - step);
            }
            else if (code == KeyCode.RIGHT) {
                snake.setCenterX(snake.getCenterX() + step);
            }

        StartScreen.stages.setResizable(false);

                });
            }
        });
    }
}